function tf_reset_cfg(cfg)--$$ can be used to create/refresh glob.cfg and (future) playerData[id].cfg (playerSpecific Options)
	if #game.players == 1 and glob.cfg and glob.cfg.developerMode == true then
		game.players[1].print( "ThunderMod: loading configuration defaults" )
	end
	--$$ create cfg table ... should already be done!! 
	--cfg = {}

	cfg.version = MOD_VERSION
	cfg.update_interval = MOD_UPDATE_INTERVAL
	cfg.thunderBox_minimalWidth = DEFAULT_THUNDERBOX_WIDTH

	cfg.viewPlayerSettings = SHOW_PLAYER_SETTINGS
	cfg.showClock = SHOW_CLOCK_PANEL
	cfg.showSpeedButton = SHOW_SPEED_BUTTON
	cfg.showSettingsButton = SHOW_SETTINGS_BUTTON

	cfg.removeElementsLeftOfSuperGui = REMOVE_ELEMENTS_LEFT_OF_SUPER_TOP_GUI
	cfg.removeGui_onSave = REMOVE_GUI_ON_SAVE
	cfg.developerMode = DEVELOPER_MODE
	cfg.safeMultiplayerMode = SAFE_MULTIPLAYER_MODE
end 

function tf_check_global_cfg()
	--$$ Cake
	--$$ (re-)Load config (if running game is using old mod-settings)
	if (not glob.cfg or glob.cfg.version == nil or glob.cfg.version ~= MOD_VERSION) then  --undefined or version change
		--$$ Perfection = performance ? Lie : Pie // end of pun \0
		if glob.cfg and ( glob.cfg.developerMode == true or DEVELOPER_MODE == true ) then
			--$$ we get here when glob.cfg is defined but: ( version is undefined or different from expectations ) and developerMode defined and true
			for _, player in pairs(game.players) do
				player.print( string.format( 
						"ThunderMod: mod-version change detected(%s). Loading configuration defaults(%s)", 
						tf_VersionString(glob.cfg.version), tf_VersionString(MOD_VERSION) ) )
			end
		end
		glob.cfg = {}
		tf_reset_cfg(glob.cfg)
		return true
	end
	return false
end

function tf_VersionString(version)
	if version == nil then return "version: unkown" end
	local version_prime = math.floor(version)
	local version_second = (version-version_prime)*10 
	local version_third = (version_second- math.floor(version_second))*10
	return string.format("version: %d.%d.%d", version_prime, math.floor(version_second), version_third )
end

function tf_reset_playerCfg(player_cfg)
	--$$ create cfg table ... should already be done!! 
	--player_cfg = {}

	--$$ viewPlayerSetting or view glob.cfg settings in setting window
	player_cfg.viewPlayerSettings = glob.cfg.viewPlayerSettings
	--$$ show clock
	player_cfg.showClock = glob.cfg.showClock
	--$$ show speed+ button
	player_cfg.showSpeedButton = glob.cfg.showSpeedButton
	--$$ show thunder+ button
	player_cfg.showSettingsButton = glob.cfg.showSettingsButton
end

function tf_reset_allPlayerCfgs()
	if glob.playerCfg == nil then
		glob.playerCfg = {}
	end
	for PIndex, player in pairs(game.players) do
		if glob.playerCfg[PIndex] == nil then
			glob.playerCfg[PIndex] = {}
		end
		tf_reset_playerCfg( glob.playerCfg[PIndex] )
	end
end

function tf_check_playerCfg(playerindex)
	if glob.playerCfg == nil then
		glob.playerCfg = {}
	end
	if glob.playerCfg[playerindex] == nil then
		glob.playerCfg[playerindex] = {}
		tf_reset_playerCfg( glob.playerCfg[playerindex] )
	end
end
